; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 640
WINDOWHEIGHT = 480
MAX_EXTENSION_SPACE  = 10240; Characters for Extension-Strings
MAX_EXTENSION_LENGTH = 256; Maximum Of Characters In One Extension-String
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
xrot	equ rot
yrot	equ rot+4
xspeed	equ speed
yspeed	equ speed+4
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	hFile:qword
;local	buffer[60h]:byte

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:
	movss	xmm0,xrot
	addss	xmm0,xspeed	;xrot+=xspeed;
	comiss	xmm0,const360;	if (xrot>360.0f) xrot-=360.0f;
	jna	@f
	subss	xmm0,const360
@@:	orps	xmm0,xmm0
	jns	@f
	addss	xmm0,const360
@@:     movss	xrot,xmm0
;	if (xrot<0.0f) xrot+=360.0f;
	movss	xmm0,yrot
	addss	xmm0,yspeed
	comiss	xmm0,const360
	jna	@f
	subss	xmm0,const360
@@:	orps	xmm0,xmm0
	jns	@f
	addss	xmm0,const360
@@:	movss	yrot,xmm0;yrot+=yspeed;
;	if (yrot>360.0f) yrot-=360.0f;
;	if (yrot<0.0f) yrot+=360.0f;
        invoke	InvalidateRect,,0,0
	jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_E
	jne	@f
	xor	emboss,1
	jmp	@0
@@:	cmp	al,VK_M
	jne	@f
;useMultitexture=((!useMultitexture) && multitextureSupported)
	mov	al,multitextureSupported
	shl	al,1
	xor	flag,2;useMultitexture=10y
	and	flag,al
	jmp	@0
@@:	cmp	al,VK_B
	jne	@f
	xor	flag,4;bumps=!bumps
	jmp	@0
@@:	cmp	al,VK_F
	jne	@f
	inc	filter
	jnp	@0
	and	filter,0;if filter>2 then filter=0
	jmp	@0
@@:	cmp	al,VK_PRIOR
	jne	@f
	movss	xmm0,z
	subss	xmm0,const0_02
	movss	z,xmm0
	jmp	@0
@@:	cmp	al,VK_NEXT
	jne	@f
	movss	xmm0,z
	addss	xmm0,const0_02
	movss	z,xmm0
	jmp	@0
@@:	cmp	al,VK_UP
	jne	@f
	movss	xmm0,xspeed
	subss	xmm0,const0_01
	movss	xspeed,xmm0
	jmp	@0
@@:	cmp	al,VK_DOWN
	jne	@f
	movss	xmm0,xspeed
	addss	xmm0,const0_01
	movss	xspeed,xmm0
	jmp	@0
@@:	cmp	al,VK_RIGHT
	jne	@f
	movss	xmm0,yspeed
	addss	xmm0,const0_01
	movss	yspeed,xmm0
	jmp	@0
@@:	cmp	al,VK_LEFT
	jne	wmBYE
	movss	xmm0,yspeed
	subss	xmm0,const0_01
	movss	yspeed,xmm0
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
	mov	edx,offset texture
	invoke	glGenTextures,3
;-------------------------------------------------------
	mov	ecx,offset BaseBMP
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,rbx
        mov	hFile,rax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax	; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	temp,rax
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize,,rbx
        invoke	CloseHandle,hFile
    	mov	eax,[rsi + BITMAPINFOHEADER.biWidth + sizeof BITMAPFILEHEADER]
        mov	w,eax
        movzx	eax, word ptr [rsi + BITMAPINFOHEADER.biHeight + sizeof BITMAPFILEHEADER]
        mov	h,eax
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]
;-------------------------------------------------------------
	push	rsi
	mov	ecx,w
	imul	ecx,h
@@:	lodsd
	bswap	eax
	ror	eax,8
	mov	[rsi-4],eax
	dec	esi;add	esi,3
	loop	@b
	pop	rsi
;-------------------------------------------------------------
; 3    
	mov	edx,texture[0*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST
	invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGB8,w,h,rbx,GL_RGB,GL_UNSIGNED_BYTE,rsi
;Use GL_RGB8 Instead Of "3" In glTexImage2D. Also Defined By GL: GL_RGBA8 Etc.
; NEW: Now Creating GL_RGBA8 Textures, Alpha Is 1.0f Where Not Specified By Format.
; Create Linear Filtered Texture
	mov	edx,texture[1*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGB8,w,h,rbx,,GL_RGB,GL_UNSIGNED_BYTE,rsi
;Create MipMapped Texture
	mov	edx,texture[2*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST
	invoke	gluBuild2DMipmaps,GL_TEXTURE_2D,GL_RGB8,w,h,GL_RGB,GL_UNSIGNED_BYTE,rsi
	invoke	GlobalFree,temp
;--------------------------------------------------------------------------------
	mov	ecx,offset BumpBMP
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,rbx
        mov	hFile,rax
	invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax	; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	temp,rax
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize,,rbx
        invoke	CloseHandle,hFile
    	mov	eax,[rsi + BITMAPINFOHEADER.biWidth + sizeof BITMAPFILEHEADER]
        mov	w,eax
        movzx	eax, word ptr [rsi + BITMAPINFOHEADER.biHeight + sizeof BITMAPFILEHEADER]
        mov	h,eax
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]
;--------------------------------------------------------------
	movss	xmm1,const0_5
	invoke	glPixelTransferf,GL_RED_SCALE; Scale RGB By 50%, So That We Have Only			
	movss	xmm1,const0_5
	invoke	glPixelTransferf,GL_GREEN_SCALE; Half Intenstity
	movss	xmm1,const0_5
	invoke	glPixelTransferf,GL_BLUE_SCALE;

	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP; No Wrapping, Please!
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP
	mov	r8d,offset Gray
	invoke	glTexParameterfv,GL_TEXTURE_2D,GL_TEXTURE_BORDER_COLOR
	mov	edx,offset bump
	invoke	glGenTextures,3
; 3    
	mov	edx,bump[0*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST
	invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGB,w,h,rbx,GL_RGB,GL_UNSIGNED_BYTE,rsi
;Use GL_RGB8 Instead Of "3" In glTexImage2D. Also Defined By GL: GL_RGBA8 Etc.
; NEW: Now Creating GL_RGBA8 Textures, Alpha Is 1.0f Where Not Specified By Format.
; Create Linear Filtered Texture
	mov	edx,bump[1*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGB,w,h,rbx,GL_RGB,GL_UNSIGNED_BYTE,rsi
;Create MipMapped Texture
	mov	edx,bump[2*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST
	invoke	gluBuild2DMipmaps,GL_TEXTURE_2D,GL_RGB,w,h,GL_RGB,GL_UNSIGNED_BYTE,rsi
;--------------------------------------------------------------------------------
	mov	edx,offset invbump
	invoke	glGenTextures,3
	push	rsi
	mov	ecx,h
	shr	ecx,3
	imul	ecx,w
	imul	ecx,3
@@:	lodsq
	not	rax
	mov	[rsi-8],rax
	loop	@b
	pop	rsi
	mov	edx,invbump[0*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST
	invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGB,w,h,rbx,GL_RGB,GL_UNSIGNED_BYTE,rsi
;Use GL_RGB8 Instead Of "3" In glTexImage2D. Also Defined By GL: GL_RGBA8 Etc.
; NEW: Now Creating GL_RGBA8 Textures, Alpha Is 1.0f Where Not Specified By Format.
; Create Linear Filtered Texture
	mov	edx,invbump[1*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGB,w,h,rbx,GL_RGB,GL_UNSIGNED_BYTE,rsi
;Create MipMapped Texture
	mov	edx,invbump[2*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST
	invoke	gluBuild2DMipmaps,GL_TEXTURE_2D,GL_RGB,w,h,GL_RGB,GL_UNSIGNED_BYTE,rsi

	movss	xmm1,const1
	invoke	glPixelTransferf,GL_RED_SCALE; Scale RGB Back To 100% Again		
	movss	xmm1,const1
	invoke	glPixelTransferf,GL_GREEN_SCALE
	movss	xmm1,const1
	invoke	glPixelTransferf,GL_BLUE_SCALE
	invoke	GlobalFree,temp
;--------------------------------------------------------------
	mov	ecx,offset OpenGLBMP
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,rbx
        mov	hFile,rax
	invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax	; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	temp,rax
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize,,rbx
	invoke	CloseHandle,hFile
    	mov	eax,[rsi + BITMAPINFOHEADER.biWidth + sizeof BITMAPFILEHEADER]
        mov	w,eax
        movzx	eax, word ptr [rsi + BITMAPINFOHEADER.biHeight + sizeof BITMAPFILEHEADER]
        mov	h,eax
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]
	push	rsi
	mov	ecx,w
	imul	ecx,h
@@:	lodsd
	bswap	eax
	ror	eax,8
	mov	[rsi-4],eax
	dec	esi;add	esi,3
	loop	@b
	pop	rsi
	mov	edx,offset glLogo
	invoke	glGenTextures,1; Create One Textures
; Create Linear Filtered RGBA8-Texture
	mov	edx, glLogo
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGB,w,h,rbx,GL_RGB,GL_UNSIGNED_BYTE,rsi
	invoke	GlobalFree,temp
;--------------------------------------------------------------
	mov	ecx,offset MultiOnAlphaBMP
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,rbx
        mov	hFile,rax
	invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax	; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	temp,rax
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize,,rbx
	invoke	CloseHandle,hFile
    	mov	eax,[rsi + BITMAPINFOHEADER.biWidth + sizeof BITMAPFILEHEADER]
        mov	w,eax
        movzx	eax, word ptr [rsi + BITMAPINFOHEADER.biHeight + sizeof BITMAPFILEHEADER]
        mov	h,eax
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]

	mov	edx,offset multiLogo
	invoke	glGenTextures,1; Create One Textures
; Create Linear Filtered RGBA8-Texture
	mov	edx,multiLogo
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexImage2D,GL_TEXTURE_2D,0,GL_RGB,w,h,rbx,GL_RGB,GL_UNSIGNED_BYTE,rsi
	invoke	GlobalFree,temp
;---------------------------------------------------------
        invoke	initMultitexture
	mov	multitextureSupported,al

        invoke	glEnable,GL_TEXTURE_2D;enable texture mapping (the img is 2D)
	invoke	glShadeModel,GL_SMOOTH;smooth shading
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor; This Will Clear The Background Color To Black
        cvtss2sd xmm0,const1
	invoke	glClearDepth;Enables Clearing Of The Depth Buffer
	invoke	glEnable,GL_DEPTH_TEST ;Enables Depth Testing
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing To Do
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST; Really Nice Perspective Calculations

	invoke	initLights; Initialize OpenGL Light


        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke	glLoadIdentity
	cmp	maxTexelUnits,1
	jna	@3
	or	flag,1
@3:	movzx	eax,flag
	call	handler[rax*8]
	invoke	doLogo
	invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn
handler dq doMesh1TexelUnits,doMesh2TexelUnits,doMesh1TexelUnits,doMesh2TexelUnits
	dq doMeshNoBumps,doMeshNoBumps,doMeshNoBumps,doMeshNoBumps
;in flag:
;bumps           2-nd bit
;useMultitexture 1-st bit
;maxTexelUnits   0-th bit
WndProc	endp
initMultitexture proc
local	extensions[100h]:byte
local	len:dword

	invoke	glGetString,GL_EXTENSIONS	; name
	mov	esi,eax
	lea	edi,extensions
	xor	ecx,ecx
@0:	lodsb
	or	al,al
	jz	@1
	cmp	al,20h
	jnz	@f
	mov	al,0Ah
@@:	stosb
	inc	ecx
	jmp	@0
@1:	mov	len,ecx
	lea	esi,extensions
	mov	edx,offset aGl_arb_multite ; "GL_ARB_multitexture"
	invoke	isInString,esi
	test	al, al
	jz	exit0
	mov	edx,offset aGl_ext_texture ; "GL_EXT_texture_env_combine"
	invoke	isInString,esi
	test	al, al
	jz	exit0
	mov	edx,offset maxTexelUnits ; params
	invoke	glGetIntegerv,GL_MAX_TEXTURE_UNITS_ARB
	mov	ecx,offset aGlmultitexcoor ; "glMultiTexCoord1fARB"
	invoke	wglGetProcAddress
	mov	glMultiTexCoord1fARB,rax
	or	eax,eax
	jz	exit0
	mov	ecx,offset aGlmultitexco_0 ; "glMultiTexCoord2fARB"
	invoke	wglGetProcAddress
	mov	glMultiTexCoord2fARB,rax
	or	eax,eax
	jz	exit0
	mov	ecx,offset aGlmultitexco_1 ; "glMultiTexCoord3fARB"
	invoke	wglGetProcAddress
	mov	glMultiTexCoord3fARB,rax
	or	eax,eax
	jz	exit0
	mov	ecx,offset aGlmultitexco_2 ; "glMultiTexCoord4fARB"
	invoke	wglGetProcAddress
	mov	glMultiTexCoord4fARB,rax
	or	eax,eax
	jz	exit0
	mov	ecx,offset aGlactivetextur ; "glActiveTextureARB"
	invoke	wglGetProcAddress	
	mov	glActiveTextureARB,rax
	or	eax,eax
	jz	exit0
	mov	ecx,offset aGlclientactive ; "glClientActiveTextureARB"
	invoke	wglGetProcAddress
	mov	glClientActiveTextureARB,rax
	or	eax,eax
	jz	exit0
	or	flag,2;=010b
	mov	al, TRUE
	jmp	@f
; ---------------------------------------------------------------------------
exit0:	and	flag,5;=101b
	xor	al, al
@@:	leave
	retn
initMultitexture endp
isInString proc string:dword,seach:dword
local	len:dword
local	maxpos:dword

	mov	seach,edx
	mov	string,ecx

	mov	edi,edx;seach
	or	ecx,-1
	xor	eax,eax
	repne	scasb
	not	ecx
	dec	ecx
	mov	maxpos,ecx
	dec	maxpos;int maxpos=strlen(search)-1

	mov	edi,string
	or	ecx,-1
	repne	scasb
	not	ecx
	dec	ecx
	mov	len,ecx;int len=strlen(string)
	jz	exit0
	mov	edi,string
@0:	test	eax, eax
	jz	@f
	cmp	eax,1
	jbe	@1
	cmp	byte ptr [rdi+rax-1],10
	jnz	@1
@@:	mov	dl,byte ptr [rdi+rax]
	xor	ecx,ecx
	cmp	dl,10
	jz	@1
@2:	cmp	dl,byte ptr [rdi+rcx]
	jnz	@f
	inc	ecx
@@:	cmp	ecx,len
	jbe	@f
	cmp	byte ptr [rdi+rax+1],10
	jz	exit1
@@:	mov	dl,byte ptr [rdi+rax+1]
	inc	eax
	cmp	dl,10
	jnz	@2
@1:	inc	eax
	cmp	eax,maxpos
	jb	@0
; ---------------------------------------------------------------------------
exit1:	mov	eax,TRUE
exit0:	leave
	retn
isInString endp	
doCube proc  dummy:dword

	invoke	glBegin,GL_QUADS
; Front Face
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f;( 0.0f, 0.0f, +1.0f);
;		for (i=0; i<4; i++) {
        mov	esi,offset data_
@@:	movss	xmm1,dword ptr [rsi+1*4]
	movss	xmm0,dword ptr [rsi+0*4]
	invoke	glTexCoord2f;(data[5*i],data[5*i+1]);
	movss	xmm2,dword ptr [rsi+4*4]
	movss	xmm1,dword ptr [rsi+3*4]
	movss	xmm0,dword ptr [rsi+2*4]
	invoke	glVertex3f;(data[5*i+2],data[5*i+3],data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+50h
	jb	@b
; Back Face
	movss	xmm2,const_1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f;( 0.0f, 0.0f,-1.0f);
	cmp	esi,offset data_+50h
@@:	movss	xmm1,dword ptr [rsi+1*4]
	movss	xmm0,dword ptr [rsi+0*4]
	invoke	glTexCoord2f;(data[5*i],data[5*i+1]);
	movss	xmm2,dword ptr [rsi+4*4]
	movss	xmm1,dword ptr [rsi+3*4]
	movss	xmm0,dword ptr [rsi+2*4]
	invoke	glVertex3f;(data[5*i+2],data[5*i+3],data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+2*50h
	jb	@b
		; Top Face
	xorps	xmm2,xmm2
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glNormal3f;( 0.0f, 1.0f, 0.0f);
	mov	esi,offset data_+2*50h	;for (i=8; i<12; i++) {
@@:	movss	xmm1,dword ptr [rsi+1*4]
	movss	xmm0,dword ptr [rsi+0*4]
	invoke	glTexCoord2f;(data[5*i],data[5*i+1]);
	movss	xmm2,dword ptr [rsi+4*4]
	movss	xmm1,dword ptr [rsi+3*4]
	movss	xmm0,dword ptr [rsi+2*4]
	invoke	glVertex3f;(data[5*i+2],data[5*i+3],data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+3*50h
	jb	@b
; Bottom Face
	xorps	xmm2,xmm2
	movss	xmm1,const_1
	xorps	xmm0,xmm0
	invoke	glNormal3f;( 0.0f,-1.0f, 0.0f);
	mov	esi,offset data_+3*50h;for (i=12; i<16; i++) {
@@:	movss	xmm1,dword ptr [rsi+1*4]
	movss	xmm0,dword ptr [rsi+0*4]
	invoke	glTexCoord2f;(data[5*i],data[5*i+1]);
	movss	xmm2,dword ptr [rsi+4*4]
	movss	xmm1,dword ptr [rsi+3*4]
	movss	xmm0,dword ptr [rsi+2*4]
	invoke	glVertex3f;(data[5*i+2],data[5*i+3],data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+4*50h
	jb	@b
; Right face
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glNormal3f;( 1.0f, 0.0f, 0.0f);
	mov	esi,offset data_+4*50h;for (i=16; i<20; i++) {
@@:	movss	xmm1,dword ptr [rsi+1*4]
	movss	xmm0,dword ptr [rsi+0*4]
	invoke	glTexCoord2f;(data[5*i],data[5*i+1]);
	movss	xmm2,dword ptr [rsi+4*4]
	movss	xmm1,dword ptr [rsi+3*4]
	movss	xmm0,dword ptr [rsi+2*4]
	invoke	glVertex3f;(data[5*i+2],data[5*i+3],data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+5*50h
	jb	@b
; Left Face
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const_1
	invoke	glNormal3f;(-1.0f, 0.0f, 0.0f);
	mov	esi,offset data_+5*50h;for (i=20; i<24; i++) {
@@:	movss	xmm1,dword ptr [rsi+1*4]
	movss	xmm0,dword ptr [rsi+0*4]
	invoke	glTexCoord2f;(data[5*i],data[5*i+1]);
	movss	xmm2,dword ptr [rsi+4*4]
	movss	xmm1,dword ptr [rsi+3*4]
	movss	xmm0,dword ptr [rsi+2*4]
	invoke	glVertex3f;(data[5*i+2],data[5*i+3],data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+6*50h
	jb	@b
	invoke	glEnd
	leave
	retn
doCube endp
doMesh1TexelUnits proc
local	c_[4]:dword; Holds Current Vertex
local	n[4]:dword; Normalized Normal Of Current Surface
local	s[4]:dword; s-Texture Coordinate Direction, Normalized
local	t[4]:dword; t-Texture Coordinate Direction, Normalized
local	l[4]:dword; Holds Our Lightposition To Be Transformed Into Object Space
local	Minv[16]:dword; Holds The Inverted Modelview Matrix To Do So.

	mov	qword ptr c_[0*4],rbx
	mov	c_[2*4],ebx
	movr	dword ptr c_[3*4],1.0
	mov	qword ptr n[0*4],rbx
	mov	n[2*4],ebx
	movr	dword ptr n[3*4],1.0
	mov	qword ptr s[0*4],rbx
	mov	s[2*4],ebx
	movr	dword ptr s[3*4],1.0
	mov	qword ptr t[0*4],rbx
	mov	t[2*4],ebx
	movr	dword ptr t[3*4],1.0
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;	; Clear The Screen And The Depth Buffer
		
	; Build Inverse Modelview Matrix First. This Substitutes One Push/Pop With One glLoadIdentity();
	; Simply Build It By Doing All Transformations Negated And In Reverse Order.
	invoke	glLoadIdentity
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	subss	xmm0,yrot
	invoke	glRotatef;(-yrot,0.0f,1.0f,0.0f);
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	xorps	xmm0,xmm0
	subss	xmm0,xrot
	invoke	glRotatef;(-xrot,1.0f,0.0f,0.0f);
	xorps	xmm2,xmm2
	subss	xmm2,z
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;(0.0f,0.0f,-z);
	lea	edx,Minv
	invoke	glGetFloatv,GL_MODELVIEW_MATRIX
	invoke	glLoadIdentity
	movss	xmm2,z
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;(0.0f,0.0f,z);
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xrot
	invoke	glRotatef;(xrot,1.0f,0.0f,0.0f);
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,yrot
	invoke	glRotatef;(yrot,0.0f,1.0f,0.0f);	
	
	; Transform The Lightposition Into Object Coordinates:
	mov	eax,LightPosition[0*4]
	mov	l[0*4],eax
	mov	eax,LightPosition[1*4]
	mov	l[1*4],eax
	mov	eax,LightPosition[2*4]
	mov	l[2*4],eax
	movr	dword ptr l[3*4],1.0;		; Homogenous Coordinate
	lea	edx,l
	lea	ecx,Minv
	invoke	VMatMult
	
;	PASS#1: Use Texture "Bump"
;No Blend
;No Lighting
;No Offset Texture-Coordinates */
	movzx	eax,filter
	mov	edx,bump[rax*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glDisable,GL_BLEND
	invoke	glDisable,GL_LIGHTING
	invoke	doCube

; PASS#2:	Use Texture "Invbump"
;Blend GL_ONE To GL_ONE
;No Lighting
;Offset Texture Coordinates 
;*/
	movzx	eax,filter
	mov	edx,invbump[rax*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glBlendFunc,GL_ONE,GL_ONE
	invoke	glDepthFunc,GL_LEQUAL
	invoke	glEnable,GL_BLEND
 
	invoke	glBegin,GL_QUADS
; Front Face	
	mov	qword ptr n[0*4],rbx
	movr	dword ptr n[2*4],1.0;
	movr	dword ptr s[0*4],1.0
	mov	qword ptr s[1*4],rbx
	mov	t[0*4],ebx
	movr	dword ptr t[1*4],1.0
	mov	t[2*4],ebx;
	mov	esi,offset data_+16
;		for (i=0; i<4; i++) {	
@@:	mov	ecx,[rsi-8]
	mov	c_[0*4],ecx;=data[5*i+2]
	mov	ecx,[rsi-4]
	mov	c_[1*4],ecx;c[1]=data[5*i+3];
	mov	ecx,[rsi]
	mov	c_[2*4],ecx;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+80+16
	jb	@b
;		}
; Back Face	
	mov	n[0*4],ebx
	mov	n[1*4],ebx
	movr	dword ptr n[2*4],-1.0;	
	movr	dword ptr s[0*4],-1.0
	mov	s[1*4],ebx
	mov	s[2*4],ebx;
	mov	t[0*4],ebx
	movr	dword ptr t[1*4],1.0
	mov	t[2*4],ebx;

	mov	esi,offset data_+80+16
;		for (i=4; i<8; i++) {	
@@:	mov	eax,[rsi-8]
	mov	c_[0*4],eax;c[0]=data[5*i+2];		
	mov	eax,[rsi-4]
	mov	c_[1*4],eax;c[1]=data[5*i+3];
	mov	eax,[rsi]
	mov	c_[2*4],eax;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps;(n,c,l,s,t);
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+c[1]); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+160+16
	jb	@b
; Top Face	
	mov	n[0*4],ebx
	movr	dword ptr n[1*4],1.0
	mov	n[2*4],ebx;		
	movr	dword ptr s[0*4],1.0
	mov	qword ptr s[1*4],rbx
	mov	qword ptr t[0*4],rbx
	movr	dword ptr t[2*4],-1.0;
	mov	esi,offset data_+160+16
;		for (i=8; i<12; i++) {	
@@:	mov	eax,[rsi-8]
	mov	c_[0*4],eax;c[0]=data[5*i+2];		
	mov	eax,[rsi-4]
	mov	c_[1*4],eax;c[1]=data[5*i+3];
	mov	eax,[rsi]
	mov	c_[2*4],eax;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps;(n,c,l,s,t);
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+c[1]); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+240+16
	jb	@b
		; Bottom Face
	mov	n[0*4],ebx
	movr	dword ptr n[1*4],-1.0
	mov	n[2*4],ebx;		
	movr	dword ptr s[0*4],-1.0
	mov	qword ptr s[1*4],rbx
	mov	qword ptr t[0*4],rbx
	movr	dword ptr t[2*4],-1.0;
	mov	esi,offset data_+240+16
;		for (i=12; i<16; i++) {	
@@:	mov	eax,[rsi-8]
	mov	c_[0*4],eax;c[0]=data[5*i+2];		
	mov	eax,dword ptr [rsi-4]
	mov	c_[1*4],eax;c[1]=data[5*i+3];
	mov	eax,dword ptr [rsi]
	mov	c_[2*4],eax;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps;(n,c,l,s,t);
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+c[1]); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+320+16
	jb	@b
		; Right Face	
	movr	dword ptr n[0*4],1.0
	mov	qword ptr n[1*4],rbx
	mov	qword ptr s[0*4],rbx
	movr	dword ptr s[2*4],-1.0;
	mov	t[0*4],ebx
	movr	dword ptr t[1*4],1.0
	mov	t[2*4],ebx;
	mov	esi,offset data_+320+16
;		for (i=16; i<20; i++) {	
@@:	mov	eax,[rsi-8]
	mov	c_[0*4],eax;c[0]=data[5*i+2];		
	mov	eax,[rsi-4]
	mov	c_[1*4],eax;c[1]=data[5*i+3];
	mov	eax,[rsi]
	mov	c_[2*4],eax;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps;(n,c,l,s,t);
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+c[1]); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+400+16
	jb	@b
		; Left Face
	movr	dword ptr n[0*4],-1.0
	mov	qword ptr n[1*4],rbx
	mov	qword ptr s[0*4],rbx
	movr	dword ptr s[2*4],1.0;
	mov	t[0*4],ebx
	movr	dword ptr t[1*4],1.0
	mov	t[2*4],ebx;
	mov	esi,offset data_+400+16
;		for (i=20; i<24; i++) {	
@@:	mov	eax,[rsi-8]
	mov	c_[0*4],eax;c[0]=data[5*i+2];		
	mov	eax,[rsi-4]
	mov	c_[1*4],eax;c[1]=data[5*i+3];
	mov	eax,[rsi]
	mov	c_[2*4],eax;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps;(n,c,l,s,t);
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+c[1]); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+480+16
	jb	@b
	invoke	glEnd
	
; PASS#3:	Use Texture "Base"
;Blend GL_DST_COLOR To GL_SRC_COLOR (Multiplies By 2)
;Lighting Enabled
;No Offset Texture-Coordinates
;*/
	cmp	emboss,0
	jnz	@f
	invoke	glTexEnvf,GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE
	movzx	eax,filter
	mov	edx,texture[rax*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glBlendFunc,GL_DST_COLOR,GL_SRC_COLOR
	invoke	glEnable,GL_LIGHTING
	invoke	doCube
@@:     leave
	ret;	; Keep Going
doMesh1TexelUnits endp


initLights proc
	enter	20h,0
	mov	r8d,offset LightAmbient
	invoke	glLightfv,GL_LIGHT1,GL_AMBIENT	; Load Light-Parameters Into GL_LIGHT1
	mov	r8d,offset LightDiffuse
	invoke	glLightfv,GL_LIGHT1,GL_DIFFUSE
	mov	r8d,offset LightPosition
	invoke	glLightfv,GL_LIGHT1,GL_POSITION

	invoke	glEnable,GL_LIGHT1
	leave
	retn
initLights endp

; Calculates v=vM, M Is 4x4 In Column-Major, v Is 4dim. Row (i.e. "Transposed")
VMatMult proc M:dword, v0:dword
local	res[3]:dword
	mov	M,ecx
	mov	v0,edx

	movss	xmm0,M[0*4]
	mulss	xmm0,v0[0*4]
	movss	xmm1,M[1*4]
	mulss	xmm1,v0[1*4]
	addss	xmm0,xmm1
	movss	xmm2,M[2*4]
	mulss	xmm2,v0[2*4]
	movss	xmm3,M[3*4]
	mulss	xmm3,v0[3*4]
	addss	xmm2,xmm3
	addss	xmm0,xmm2
	movss	res[0*4],xmm0;res[0]=M[ 0]*v[0]+M[ 1]*v[1]+M[ 2]*v[2]+M[ 3]*v[3]
	movss	v0[0],xmm0;v[0]=res[0]
	movss	xmm0,M[4*4]
	mulss	xmm0,v0[0*4]
	movss	xmm1,M[5*4]
	mulss	xmm1,v0[1*4]
	addss	xmm0,xmm1
	movss	xmm2,M[6*4]
	mulss	xmm2,v0[2*4]
	movss	xmm3,M[7*4]
	mulss	xmm3,v0[3*4]
	addss	xmm2,xmm3
	addss	xmm0,xmm2
	movss	res[1*4],xmm0;res[1]=M[ 4]*v[0]+M[ 5]*v[1]+M[ 6]*v[2]+M[ 7]*v[3];
	movss	v0[1*4],xmm0;v[1]=res[1]
	movss	xmm0,M[8*4]
	mulss	xmm0,v0[0*4]
	movss	xmm1,M[9*4]
	mulss	xmm1,v0[1*4]
	addss	xmm0,xmm1
	movss	xmm2,M[10*4]
	mulss	xmm2,v0[2*4]
	movss	xmm3,M[11*4]
	mulss	xmm3,v0[3*4]
	addss	xmm2,xmm3
	addss	xmm0,xmm2
	movss	res[2*4],xmm0;res[2]=M[ 8]*v[0]+M[ 9]*v[1]+M[10]*v[2]+M[11]*v[3];;	
	movss	v0[2*4],xmm0;v[2]=res[2]
	mov	eax,M[15*4];v[3]=M[15]		 Homogenous Coordinate
	mov	v0[3*4],eax
	leave
	ret
VMatMult endp	
SetUpBumps proc n:dword, c_:dword, l:dword, s:dword, t:dword
local	v0[3]:dword;Vertex From Current Position To Light	
local	lenQ:dword;Used To Normalize
		
	mov	n,ecx
	mov	c_,edx
	mov	l,r8d
	mov	s,r9d		

; Calculate v From Current Vector c To Lightposition And Normalize v	
	movss	xmm0,dword ptr [r8+0*4]
	subss	xmm0,dword ptr [rdx+0*4]
	movss	v0[0*4],xmm0;v[0]=l[0]-c[0];		
	mulss	xmm0,xmm0
	movss	xmm1,dword ptr [r8+1*4]
	subss	xmm1,dword ptr [rdx+1*4]
	movss	v0[1*4],xmm1;v[1]=l[1]-c[1];		

	mulss	xmm1,xmm1
	addss	xmm0,xmm1

	movss	xmm2,dword ptr [r8+2*4]
	subss	xmm2,dword ptr [rdx+2*4]
	movss	v0[2*4],xmm2;v[2]=l[2]-c[2];		
	mulss	xmm2,xmm2

	addss	xmm0,xmm2
	sqrtps	xmm0,xmm0
	movss	lenQ,xmm0;lenQ=(GLfloat) sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
	movss	xmm0,v0[0*4]
	divss	xmm0,lenQ
	movss	v0[0*4],xmm0;v[0]/=lenQ
	movss	xmm0,v0[1*4]
	divss	xmm0,lenQ
	movss	v0[1*4],xmm0;v[1]/=lenQ
	movss	xmm0,v0[2*4]
	divss	xmm0,lenQ
	movss	v0[2*4],xmm0;v[2]/=lenQ;
	; Project v Such That We Get Two Values Along Each Texture-Coordinat Axis.
	movss	xmm0,dword ptr [r9+0*4]
	mulss	xmm0,v0[0*4]
	movss	xmm1,dword ptr [r9+1*4]
	mulss	xmm1,v0[1*4]
	addss	xmm0,xmm1
	movss	xmm2,dword ptr [r9+2*4]
	mulss	xmm2,v0[2*4]
	addss	xmm0,xmm2
	mulss	xmm0,MAX_EMBOSS
	movss	dword ptr [rdx+0*4],xmm0;c[0]=(s[0]*v[0]+s[1]*v[1]+s[2]*v[2])*MAX_EMBOSS;
	mov	eax,t
	movss	xmm0,dword ptr [rax+0*4]
	mulss	xmm0,v0[0*4]
	movss	xmm1,dword ptr [rax+1*4]
	mulss	xmm1,v0[1*4]
	addss	xmm0,xmm1
	movss	xmm2,dword ptr [rax+2*4]
	mulss	xmm2,v0[2*4]
	addss	xmm0,xmm2
	mulss	xmm0,MAX_EMBOSS
	movss	dword ptr [rdx+1*4],xmm0;c[1]=(t[0]*v[0]+t[1]*v[1]+t[2]*v[2])*MAX_EMBOSS;	
	leave
	ret
SetUpBumps endp

doLogo proc dummy:dword; MUST CALL THIS LAST!!!, Billboards The Two Logos.
	invoke	glDepthFunc,GL_ALWAYS
	invoke	glBlendFunc,GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA
	invoke	glEnable,GL_BLEND
	invoke	glDisable,GL_LIGHTING
	invoke	glLoadIdentity
	mov	edx,glLogo
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glBegin,GL_QUADS
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f,0.0f)
	movss	xmm2,const_1
	movss	xmm1,const_0_4
	movss	xmm0,const0_23
	invoke	glVertex3f;(0.23f, -0.4f,-1.0f);
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f,0.0f)
	movss	xmm2,const_1
	movss	xmm1,const_0_4
	movss	xmm0,const0_53
	invoke	glVertex3f;(0.53f, -0.4f,-1.0f);
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f,1.0f)
	movss	xmm2,const_1
	movss	xmm1,const_0_25
	movss	xmm0,const0_53
	invoke	glVertex3f;(0.53f, -0.25f,-1.0f);
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f,1.0f)
	movss	xmm2,const_1
	movss	xmm1,const_0_25
	movss	xmm0,const0_23
	invoke	glVertex3f;(0.23f, -0.25f,-1.0f);
	invoke	glEnd
	test	flag,10y;cmp	useMultitexture,0
	jz	@f
	mov	edx,multiLogo
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glBegin,GL_QUADS
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f,0.0f)
	movss	xmm2,const_1
	movss	xmm1,const_0_4
	movss	xmm0,const_0_53
	invoke	glVertex3f;(-0.53f, -0.4f,-1.0f);
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f,0.0f)
	movss	xmm2,const_1
	movss	xmm1,const_0_4
	movss	xmm0,const_0_33
	invoke	glVertex3f;(-0.33f, -0.4f,-1.0f);
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f,1.0f)
	movss	xmm2,const_1
	movss	xmm1,const_0_3
	movss	xmm0,const_0_33
	invoke	glVertex3f;(-0.33f, -0.3f,-1.0f);
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f,1.0f)
	movss	xmm2,const_1
	movss	xmm1,const_0_3
	movss	xmm0,const_0_53
	invoke	glVertex3f;(-0.53f, -0.3f,-1.0f);
	invoke	glEnd
@@:	invoke	glDepthFunc,GL_LEQUAL;
	leave
	retn
doLogo endp

doMesh2TexelUnits proc
local	c_[4]:dword; Holds Current Vertex
local	n[4]:dword; Normalized Normal Of Current Surface
local	s[4]:dword; s-Texture Coordinate Direction, Normalized
local	t[4]:dword; t-Texture Coordinate Direction, Normalized
local	l[4]:dword; Holds Our Lightposition To Be Transformed Into Object Space
local	Minv[16]:dword; Holds The Inverted Modelview Matrix To Do So.
	
	mov	qword ptr c_[0*4],rbx
	mov	c_[2*4],ebx
	movr	dword ptr c_[3*4],1.0; holds current vertex
	mov	qword ptr n[0*4],rbx
	mov	n[2*4],ebx
	movr	dword ptr n[3*4],1.0; normalized normal of current surface
	mov	qword ptr s[0*4],rbx
	mov	s[2*4],ebx
	movr	dword ptr s[3*4],1.0; s-texture coordinate direction, normalized
	mov	qword ptr t[0*4],rbx
	mov	t[2*4],ebx
	movr	dword ptr t[3*4],1.0; t-texture coordinate direction, normalized
;	GLfloat l[4];	; holds our lightposition to be transformed into object space
;	GLfloat Minv[16];; holds the inverted modelview matrix to do so.

	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;	; Clear The Screen And The Depth Buffer
		
	; Build Inverse Modelview Matrix First. This Substitutes One Push/Pop With One glLoadIdentity();
	; Simply Build It By Doing All Transformations Negated And In Reverse Order.
	invoke	glLoadIdentity
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	subss	xmm0,yrot
	invoke	glRotatef;(-yrot,0.0f,1.0f,0.0f);
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	xorps	xmm0,xmm0
	subss	xmm0,xrot
	invoke	glRotatef;(-xrot,1.0f,0.0f,0.0f);
	xorps	xmm2,xmm2
	subss	xmm2,z
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;(0.0f,0.0f,-z);
	lea	edx,Minv
	invoke	glGetFloatv,GL_MODELVIEW_MATRIX
	invoke	glLoadIdentity

	movss	xmm2,z
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;(0.0f,0.0f,z);
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xrot
	invoke	glRotatef;(xrot,1.0f,0.0f,0.0f);
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,yrot
	invoke	glRotatef;(yrot,0.0f,1.0f,0.0f);	
	; Transform The Lightposition Into Object Coordinates:
	mov	eax,LightPosition[0*4]
	mov	l[0*4],eax;	l[0]=LightPosition[0]
	mov	eax,LightPosition[1*4]
	mov	l[1*4],eax;	l[1]=LightPosition[1]
	mov	eax,LightPosition[2*4]
	mov	l[2*4],eax;	l[2]=LightPosition[2]
	movr	dword ptr l[3*4],1.0; Homogenous Coordinate
	lea	edx,l
	lea	ecx,Minv
	invoke	VMatMult
	; TEXTURE-UNIT #0		
	invoke	glActiveTextureARB,GL_TEXTURE0_ARB
	invoke	glEnable,GL_TEXTURE_2D
	movzx	eax,filter
	mov	edx,bump[rax*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexEnvf,GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE_EXT
	invoke	glTexEnvf,GL_TEXTURE_ENV, GL_COMBINE_RGB_EXT, GL_REPLACE
	; TEXTURE-UNIT #1:
	invoke	glActiveTextureARB,GL_TEXTURE1_ARB
	invoke	glEnable,GL_TEXTURE_2D
	movzx	eax,filter
	mov	edx,invbump[rax*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexEnvf,GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE_EXT
	invoke	glTexEnvf,GL_TEXTURE_ENV, GL_COMBINE_RGB_EXT, GL_ADD
	; General Switches:
	invoke	glDisable,GL_BLEND
	invoke	glDisable,GL_LIGHTING
	invoke	glBegin,GL_QUADS
; Front Face	
	mov	qword ptr n[0*4],rbx
;	mov	n[1*4],ebx
	movr	dword ptr n[2*4],1.0;
	movr	dword ptr s[0*4],1.0
	mov	qword ptr s[1*4],rbx
;	mov	s[2*4],ebx;
	mov	t[0*4],ebx
	movr	dword ptr t[1*4],1.0
	mov	t[2*4],ebx
	mov	esi,offset data_+16
;		for (i=0; i<4; i++) {	
@@:	mov	ecx,[rsi-8]
	mov	c_[0*4],ecx;=data[5*i+2]
	mov	ecx,[rsi-4]
	mov	c_[1*4],ecx;c[1]=data[5*i+3];
	mov	ecx,[rsi]
	mov	c_[2*4],ecx;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+80+16
	jb	@b
; Back Face	
	mov	qword ptr n[0*4],rbx
;	mov	n[1*4],ebx
	movr	dword ptr n[2*4],-1.0;	
	movr	dword ptr s[0*4],-1.0
	mov	qword ptr s[1*4],rbx
;	mov	s[2*4],ebx;
	mov	t[0*4],ebx
	movr	dword ptr t[1*4],1.0
	mov	t[2*4],ebx;

	mov	esi,offset data_+80+16
;		for (i=4; i<8; i++) {	
@@:	mov	eax,[rsi-8]
	mov	c_[0*4],eax;c[0]=data[5*i+2];		
	mov	eax,[rsi-4]
	mov	c_[1*4],eax;c[1]=data[5*i+3];
	mov	eax,[rsi]
	mov	c_[2*4],eax;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps;(n,c,l,s,t);
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+c[1]); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+160+16
	jb	@b
; Top Face	
	mov	n[0*4],ebx
	movr	dword ptr n[1*4],1.0
	mov	n[2*4],ebx;		
	movr	dword ptr s[0*4],1.0
	mov	qword ptr s[1*4],rbx
	mov	qword ptr t[0*4],rbx
	movr	dword ptr t[2*4],-1.0;
	mov	esi,offset data_+160+16
;		for (i=8; i<12; i++) {	
@@:	mov	eax,[rsi-8]
	mov	c_[0*4],eax;c[0]=data[5*i+2];		
	mov	eax,[rsi-4]
	mov	c_[1*4],eax;c[1]=data[5*i+3];
	mov	eax,[rsi]
	mov	c_[2*4],eax;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps;(n,c,l,s,t);
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+c[1]); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+240+16
	jb	@b
; Bottom Face
	mov	n[0*4],ebx
	movr	dword ptr n[1*4],-1.0
	mov	n[2*4],ebx;		
	movr	dword ptr s[0*4],-1.0
	mov	qword ptr s[1*4],rbx
	mov	qword ptr t[0*4],rbx
	movr	dword ptr t[2*4],-1.0;
	mov	esi,offset data_+240+16
;		for (i=12; i<16; i++) {	
@@:	mov	eax,[rsi-8]
	mov	c_[0*4],eax;c[0]=data[5*i+2];		
	mov	eax,dword ptr [rsi-4]
	mov	c_[1*4],eax;c[1]=data[5*i+3];
	mov	eax,dword ptr [rsi]
	mov	c_[2*4],eax;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps;(n,c,l,s,t);
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+c[1]); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+320+16
	jb	@b
; Right Face	
	movr	dword ptr n[0*4],1.0
	mov	qword ptr n[1*4],rbx
	mov	qword ptr s[0*4],rbx
	movr	dword ptr s[2*4],-1.0;
	mov	t[0*4],ebx
	movr	dword ptr t[1*4],1.0
	mov	t[2*4],ebx;
	mov	esi,offset data_+320+16
;		for (i=16; i<20; i++) {	
@@:	mov	eax,[rsi-8]
	mov	c_[0*4],eax;c[0]=data[5*i+2];		
	mov	eax,[rsi-4]
	mov	c_[1*4],eax;c[1]=data[5*i+3];
	mov	eax,[rsi]
	mov	c_[2*4],eax;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps;(n,c,l,s,t);
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+c[1]); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+400+16
	jb	@b
; Left Face
;		for (i=20; i<24; i++) {
	movr	dword ptr n[0*4],-1.0
	mov	qword ptr n[1*4],rbx
	mov	qword ptr s[0*4],rbx
	movr	dword ptr s[2*4],1.0;
	mov	t[0*4],ebx
	movr	dword ptr t[1*4],1.0
	mov	t[2*4],ebx;
	mov	esi,offset data_+400+16

@@:	mov	eax,[rsi-8]
	mov	c_[0*4],eax;c[0]=data[5*i+2];		
	mov	eax,[rsi-4]
	mov	c_[1*4],eax;c[1]=data[5*i+3];
	mov	eax,[rsi]
	mov	c_[2*4],eax;c[2]=data[5*i+4];
	lea	ecx,n
	lea	edx,c_
	lea	r8d,l
	lea	r9d,s
	lea	eax,t
	mov	[rsp+20h],rax
	invoke	SetUpBumps;(n,c,l,s,t);
	movss	xmm1,c_[1*4]
	addss	xmm1,dword ptr [rsi-12]
	movss	xmm0,c_[0*4]
	addss	xmm0,dword ptr [rsi-16]
	invoke	glTexCoord2f;(data[5*i]+c[0], data[5*i+1]+c[1]); 
	movss	xmm2,dword ptr [rsi]
	movss	xmm1,dword ptr [rsi-4]
	movss	xmm0,dword ptr [rsi-8]
	invoke	glVertex3f;(data[5*i+2], data[5*i+3], data[5*i+4]);
	add	esi,20
	cmp	esi,offset data_+480+16
	jb	@b
	invoke	glEnd		
; PASS#2	Use Texture "Base"
;Blend GL_DST_COLOR To GL_SRC_COLOR (Multiplies By 2)
;Lighting Enabled
;No Offset Texture-Coordinates
;*/	
	invoke	glActiveTextureARB,GL_TEXTURE1_ARB
	invoke	glDisable,GL_TEXTURE_2D
	invoke	glActiveTextureARB,GL_TEXTURE0_ARB

	cmp	emboss,0
	jnz	@f
	invoke	glTexEnvf,GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE
	movzx	eax,filter
	mov	edx,texture[rax*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glBlendFunc,GL_DST_COLOR,GL_SRC_COLOR
	invoke	glEnable,GL_LIGHTING
	invoke	doCube

@@:	leave
	ret; Keep Going
doMesh2TexelUnits endp
doMeshNoBumps proc dummy:dword

	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear The Screen And The Depth Buffer
	invoke	glLoadIdentity; Reset The View
	movss	xmm2,z
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;(0.0f,0.0f,z);
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xrot
	invoke	glRotatef;(xrot,1.0f,0.0f,0.0f);
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,yrot
	invoke	glRotatef;(yrot,0.0f,1.0f,0.0f);	
	test	flag,10y;cmp	useMultitexture,0
	jmp	@f
	invoke	glActiveTextureARB,GL_TEXTURE1_ARB
	invoke	glDisable,GL_TEXTURE_2D
	invoke	glActiveTextureARB,GL_TEXTURE0_ARB
@@:	invoke	glDisable,GL_BLEND

	movzx	eax,filter
	mov	edx,texture[rax*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glBlendFunc,GL_DST_COLOR,GL_SRC_COLOR
	invoke	glEnable,GL_LIGHTING
	invoke	doCube
	
	leave
	retn
doMeshNoBumps endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#22: GL_ARB_multitexture & Bump Mapping Tutorial",0
FileName	db "br_Rabbit3.cur",0
;FileName2	dq BaseBMP,BumpBMP,MultiOnBMP,MultiOnAlphaBMP,OpenGLBMP,OpenGLAlphaBMP
BaseBMP		db "Base.bmp",0
BumpBMP		db "Bump.bmp",0
MultiOnBMP	db "Multi_On.bmp",0
MultiOnAlphaBMP	db "Multi_On_Alpha.bmp",0
OpenGLBMP	db "OpenGL.bmp",0
;OpenGLAlphaBMP	db "OpenGL_Alpha.bmp",0
MAX_EMBOSS 	dd 0.008; Maximum Emboss-Translate. Increase To Get Higher Immersion
multitextureSupported db FALSE; Flag Indicating Whether Multitexturing Is Supported
;useMultitexture db TRUE; Use It If It Is Supported?
maxTexelUnits	dd 1
temp		dq ?
texture		dd ?,?,?
bump		dd ?,?,?; Our Bumpmappings
invbump		dd ?,?,?; Inverted Bumpmaps
aGl_arb_multite db "GL_ARB_multitexture",0
aGlclientactive db "glClientActiveTextureARB",0
aGl_ext_texture db "GL_EXT_texture_env_combine",0
aGlmultitexcoor db "glMultiTexCoord1fARB",0
aGlmultitexco_0 db "glMultiTexCoord2fARB",0
aGlmultitexco_1 db "glMultiTexCoord3fARB",0
aGlmultitexco_2 db"glMultiTexCoord4fARB",0
aGlactivetextur db "glActiveTextureARB",0
emboss		db FALSE; Emboss Only, No Basetexture?
flag		db 00000100y
z 		dd -5.0; Depth Into The Screen
filter		db 0; Which Filter To Use
glLogo		dd ?; Handle For OpenGL-Logo
multiLogo	dd ?; Handle For Multitexture-Enabled-Logo
LightAmbient	dd 0.2, 0.2, 0.2; Ambient Light is 20% white
LightDiffuse	dd 1.0, 1.0, 1.0; Diffuse Light is white
LightPosition	dd 0,     0, 2.0; Position is somewhat in front of screen
Gray 		dd 0.5, 0.5, 0.5, 1.0;
; Data Contains The Faces For The Cube In Format 2xTexCoord, 3xVertex;
; Note That The Tesselation Of The Cube Is Only Absolute Minimum.
data_:
; FRONT FACE
	dd	0.0, 0.0,-1.0, -1.0, +1.0
	dd	1.0, 0.0,+1.0, -1.0, +1.0
	dd	1.0, 1.0,+1.0, +1.0, +1.0
	dd	0.0, 1.0,-1.0, +1.0, +1.0
; BACK FACE
	dd	1.0, 0.0,-1.0, -1.0, -1.0
	dd	1.0, 1.0,-1.0, +1.0, -1.0
	dd	0.0, 1.0,+1.0, +1.0, -1.0
	dd	0.0, 0.0,+1.0, -1.0, -1.0
; Top Face
	dd	0.0, 1.0,-1.0, +1.0, -1.0
	dd	0.0, 0.0,-1.0, +1.0, +1.0
	dd	1.0, 0.0,+1.0, +1.0, +1.0
	dd	1.0, 1.0,+1.0, +1.0, -1.0
; Bottom Face
	dd	1.0, 1.0,-1.0, -1.0, -1.0
	dd	0.0, 1.0,+1.0, -1.0, -1.0
	dd	0.0, 0.0,+1.0, -1.0, +1.0
	dd	1.0, 0.0,-1.0, -1.0, +1.0
; Right Face
	dd	1.0, 0.0,+1.0, -1.0, -1.0
	dd	1.0, 1.0,+1.0, +1.0, -1.0
	dd	0.0, 1.0,+1.0, +1.0, +1.0
	dd	0.0, 0.0,+1.0, -1.0, +1.0
;Left Face
	dd	0.0, 0.0,-1.0, -1.0, -1.0
	dd	1.0, 0.0,-1.0, -1.0,  1.0
	dd	1.0, 1.0,-1.0,  1.0,  1.0
	dd	0.0, 1.0,-1.0,  1.0, -1.0
;-----------------------------
;float
const0_002 	dd 0.002
const0_01 	dd 0.01
const0_02 	dd 0.02
const0_23	dd 0.23
const_0_25	dd -0.25
const_0_3	dd -0.3
const_0_33	dd -0.33
const_0_4	dd -0.4
const0_5	dd 0.5
const0_53	dd 0.53
const_0_53	dd -0.53
const1		dd 1.0
const_1		dd -1.0
const1_1	dd 1.1
const_1_1	dd -1.1
const_2		dd -2.0
const3		dd 3.0
const4		dd 4.0
const360	dd 360.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
align 16
rot	dd 0,0,0,0;X and Y Rotation
speed	dd 0,0,0,0;X and Y Rotation Speed
glActiveTextureARB dq ?
glClientActiveTextureARB dq ?
glMultiTexCoord1fARB dq ?
glMultiTexCoord2fARB dq ?
glMultiTexCoord3fARB dq ?
glMultiTexCoord4fARB dq ?
end